# free-for-dev
Developers and Open Source authors now have a massive amount of services offering free tiers but it can be hard to find them all in order to make informed decisions.

This then is a list of software, SaaS, PaaS, IaaS etc offerings that have free tiers for devs.

The scope of this particular list is limited to things infrastructure developers - System Administrator, DevOps Practitioners etc -  are likely to find useful. We love all the free services out there but it would be good to keep it on topic.  It's a bit of a grey line at times so this is a bit oppinionate, do not be offended if I do not accept your contribution.

You can help by sending Pull Requests to add more services. Once I have a good set of link in this README file I'll look into a better layout for the information and links, help with that appreciated too.

If you're not inclined to make PRs you can tweet me at ```@ripienaar```


## Source Code Repos

  * https://bitbucket.org/ - Unlimited public and private git repos for small teams
  * https://github.com – Free for an unlimited number of public repositories
  * https://about.gitlab.com/ - Unlimited public and private git repos with unlimited collaborators

## Tools for teams & Collaboration

  * http://www.hall.com/ - Free for unlimited users with some feature limitations
  * https://www.flowdock.com/ - Chat and inbox, free for teams of 5 or less
  * https://slack.com - Free for unlimited users with some feature limitations
  * https://hipchat.com - Free for unlimited users with some feature limitations
  * https://gitter.im - "Chat, for GitHub". Free for public rooms.
  * https://kato.im - Team Chat & Collaboration, free for unlimited users with some feature limitations

## Code Quality

  * https://landscape.io/ - Code Quality for Python projects, free for Open Source
  * https://codeclimate.com/ - Automated code review, free for Open Source
  * https://houndci.com/ - Comments on github commits about code quality - free for open source
  * https://coveralls.io/ - Display test coverage reports - free for open source
  * https://scrutinizer-ci.com/ - Continuous inspection platform - free for open source
  * https://codecov.io/ - Code coverage tool (SaaS) free for 1 private project and no restrictions for publics repos

## CI / CD

  * https://codeship.com/ - 100 private builds / month, 5 private projects.  Unlimited for Open Source
  * https://circleci.com – free for one concurrent build
  * https://travis-ci.org – free for public Github repositories.
  * http://wercker.com/ - free for public and private repositories
  * https://drone.io/ - CI platform that includes browser testing, free for Open Source
  * https://semaphoreci.com/ - 100 private builds / month. Unlimited for Open Source.
  * http://www.shippable.com/ - free for 1 build container, private and public repos, unlimited builds.
  * https://snap-ci.com - free for public repositories, 1 build at the time
  * [Comparison of Continuous Integration services](https://github.com/ligurio/Continuous-Integration-services)

## Security and PKI

  * https://www.globalsign.com/en/ssl/ssl-open-source/ - Free SSL certs for Open Source projects
  * https://www.startssl.com/ - Free SSL certs
  * https://stormpath.com/ - Free user management, authentication, social login, and SSO.
  * https://auth0.com/ - hosted free for development SSO
  * https://getclef.com/ - new take on auth unlimited free tier for anyone not using premium features
  * https://ringcaptcha.com/ - tools to use phone number as id, available for free


## Management Systems

  * https://opbeat.com/ - release, deploy, monitor.  Free for 3 users

## Log Management

  * https://papertrailapp.com/ - 48 hours search, 7 day archive, 100MB/month
  * https://logentries.com/ - Free up to 5GB/month with 7 day retention
  * https://www.loggly.com/ - Free for a single user, see the ```lite``` option
  * http://sematext.com/logsene - Free for 1M logs, unlimited retention

## Analytics
  * http://www.splunk.com/en_us/products/splunk-cloud.html - upload 5GB of data per day up to 28GB of total data stored
  * * https://parse.com - Unlimited free analytics

## Monitoring
  * https://www.thousandeyes.com  - network & user experience monitoring. 3 locations plus 20 data feeds of major web services free.
  * https://www.datadoghq.com/ - Free for up to 5 nodes
  * http://www.stackdriver.com/ - Free for up to 10 nodes/services
  * https://keymetrics.io/ - Free for 2 servers with 7 days data retention
  * http://newrelic.com/ - Free with 24 hour data retention
  * https://nodequery.com/ - Free basic server monitor up to 10 servers
  * https://www.pingdom.com/free/ - 1 site free
  * https://www.opsgenie.com/ - Alert management with mobile push. 600 free alerts for 2 users a month
  * https://www.runscope.com/ - Monitor and log API usage.  Single user 10,000 request/month free
  * http://www.circonus.com/ - Free for 20 metrics
  * https://uptimerobot.com/ - Website monitoring, 50 monitors free
  * https://www.statuscake.com/ - Website monitoring, unlimited tests free with limitations
  * http://www.boundary.com/ - Free 1 second resolution for up to 10 servers
  * https://ghostinspector.com/ - Free website and web application monitoring. Single user, 100 test runs per month
  * http://java-monitor.com/ - Free monitoring of JVM's and uptime
  * http://sematext.com/spm - Free for 24h metrics, unlimited number of servers, 10 custom metrics, 500K custom metrics data points, unlimited dashboards, users, etc.

## Crash / Exception handling
  * https://rollbar.com/ - Exception and error monitoring, free plan - 5000 errors/month, unlimited users, 30 days retention.
  * https://bugsnag.com/ - Free for up to 2000 errors a month after the initial trial
  * https://airbrake.io/ - Free for 1 project, 1 user, 2 errors per minute, 2 day retention
  * http://getsentry.com/ - Sentry tracks app exceptions in realtime. has a small free plan

## Search

  * https://swiftype.com – hosted search solution (API and crawler). Free for a single search engine with up to 1000 documents. Free upgrade to Premuim level for open-source projects.

## Email

  * http://www.mailgun.com/ - First 10 000 emails are free
  * http://mailchimp.com/ - Send 12,000 emails to 2,000 subscribers for free
  * http://sendgrid.com/ - 400 emails per day for free
  * http://mandrill.com/ - First 12,000 emails are free
  * https://www.phplist.com/ - Hosted version allow 300 mails per months for free
  * https://www.mailjet.com/ - 6000 mails per months for free
  * https://www.sendinblue.com/ - 9000 mails per months for free

## CDN and Protection
  * http://www.cloudflare.com/ - Basic service is free, good for a blog etc
  * http://www.bootstrapcdn.com/ - CDN for bootstrap, bootswatch and font awesome
  * https://surge.sh - Zero-bullshit, single–command, bring your own source control web publishing CDN.

## PaaS

  * http://aws.amazon.com/free/ - AWS Free Tier - free for 12 months
  * https://cloud.google.com/appengine/ - Google App Engine gives 28 instance hours free, 1Gb NoSQL Database and more.
  * https://www.engineyard.com - Engine Yard provides 500 free hours
  * http://azure.microsoft.com/ - MS Azure gives $200 worth of free usage for a trial
  * http://hpcloud.com/ - $300 credit over 90 days.
  * https://appharbor.com/ - A .Net PaaS that provides 1 free worker
  * https://www.heroku.com/ - Host your apps in the cloud, free for single process apps
  * https://www.firebase.com/ - Build realtime apps, free plan has 50 Max Connections, 5 GB Data Transfer, 100 MB Data Storage.
1 GB Hosting Storage and 100 GB Hosting Transfer.
  * https://bluemix.net/ - IBM PaaS with a monthly free allowance
  * https://www.openshift.com/ - RedHat OpenShift offers 3 free hosted apps
  * https://bitnami.com/ - One free small app
  * https://scalingo.com - Free Tier, up to 3 apps, 1 container each, combined with data store addons free tier
  * https://algorithmia.com - Host algorithms for free - includes 10,000 credits (seconds of on-demand execution time) free
  * https://bigml.com/ - Hosted machine learning algorithms. Unlimited free tasks for development, limit of 16MB data per task
  * https://www.activestate.com/stackato/ - Enterprise-hardened Cloud Foundry PaaS from ActiveState, for private, public and hybrid cloud, free up to 20GB

## BaaS
  * https://www.parse.com - Mobile backends, free plan has 30 requests per second, with 20 GB of file and database storage, as well as push notifications for up to 1,000,000 unique recipients.


## Web Hosting

  * https://www.simplybuilt.com - SimplyBuilt offers free website building and hosting for open source projects (http://www.simplybuilt.com/explore/free-websites-for-open-source-projects). Simple alternative to GitHub Pages.

## IaaS

  * https://exoscale.ch/ - Free resources for Open Source projects
  * https://cloudant.com/ - Hosted database from IBM, free if usage is below $50/month
  * https://developer.rackspace.com/ - Rackspace Cloud gives $50/month for 12 months
  * https://cloud.google.com/compute/ - Google Compute Engine gives $300 over 60 days
  * https://cloud.google.com/container-engine/ - Google Container Engine for run Docker containers(Alpha). Pricing: same of Google Compute Engine.

## DBaaS
   * https://mongolab.com/ - MongoDB as a service (500mb free)
   * https://realm.io - Free to use even for commercial projects, under Apache 2.0 License
   * https://orchestrate.io/ - 1 application free
   * https://redislabs.com/redis-cloud - Redis as a Service (25 mb free)
   * https://www.backand.com/ - Back-end as a service (for AngularJS)
   * http://www.zenginehq.com - Build business workflow apps in minutes - free for single users

## STUN, WebRTC, Web Socket Servers and other Routers
   * https://pusher.com. Hosted Web Sockets broker. Free for up to 20 simultaneous connections and 100k messages a day.
   * stun:stun.l.google.com:19302 - Google STUN
   * stun:global.stun.twilio.com:3478?transport=udp - Twilio STUN
   * https://www.segment.com. Hub to translate and route events to other third party services. 100k events a month free.

## Issue tracking / Project management

   * https://www.atlassian.com/opensource/overview - Free Jira etc for Open Source projects
   * https://kanbanflow.com/ - Board based project management. Free (premium version with more options).
   * https://trello.com/ - Board based project management. Free
   * https://waffle.io/ - Board based project management solution from your existing GitHub Issues. Free for open-source.
   * https://huboard.com/ - Instant project management for your GitHub issues. Free for open-source.
   * https://taiga.io/ - Project management platform for startups and agile developers. Free for open-source.
   * https://www.jetbrains.com/youtrack/buy/open_source_incloud.jsp - Free hosted YouTrack (InCloud) for FOSS projects (private projects free for 10 users: https://www.jetbrains.com/youtrack/buy/)
   * https://github.com - In addition to it's git storage facility, github offers basic issue tracking
   * https://asana.com - Free for private project with collaborators.
   * http://www.acunote.com/ - Free project management and SCRUM software for up to 5 team members.

## Storage and Media Processing

   * https://www.aerofs.com/ - behind-the-firewall dropbox, free for 30 users
   * http://cloudinary.com - Image upload, powerful manipulations, storage, and delivery for sites and apps, with libraries for Ruby, Python, Java, PHP, Objective-C and more. Perpetual free tier includes 7500 images/month, 2gb storage, 5gb bandwidth.

## IDE and Code Editing
   * https://c9.io - IDE in a browser. Incorporates an Ubuntu virtual machine and in-browser terminal access. Integrates with github and bitbucket, but also adds SFTP and generic Git access.
   * https://koding.com - IDE in a browser. Features: Full sudo access - VMs hosted on Amazon EC2 - SSH Access - Real EC2 VM, no LXCs/hypervising - Custom sub-domains - Publicly accessible IP - Ubuntu 14.04 - IDE/Terminal/Collaboration
   * https://www.nitrous.io - Private Linux instance(s) with interactive collaboration {[More Details](http://goo.gl/J1Zbsg)}
   * http://visualstudio.com/free - Fully-featured IDE with thousands of extensions, cross-platform app development (Microsoft extensions available for download for iOS and Android), desktop, web and cloud development, multi-language support (C#, C++, JavaScript, Python, PHP and more).
   * https://wakatime.com - quantified self metrics about your coding activity, using text editor plugins - Limited plan for free.

## Analytics, Events and  Statistics
 * https://www.librato.com/ - Event/Data collection service with analysis and graphs. Limited plan for free.
 * https://google.com/analytics/ - Google Analytics
 * http://sematext.com/search-analytics - Free for up to 50K actions/month, 1 day data retention, unlimited dashboards, users, etc.

## Other Packs
 * https://education.github.com/pack - As long as you're a student at an recognized university

## Docker Related
### Alternate container hosting

  * https://quay.io/ - unlimited free public containers

## Vagrant Related
### Vagrant box indexes

  * https://atlas.hashicorp.com/boxes/search - HashiCorp's index of boxes
  * http://vagrantbox.es - an alternative public box index

## Data mining
  * http://www.monkeylearn.com/ - Text mining in the cloud, 1,000 queries for free per month.
